// Copyright 2021, Observable Inc.
// Released under the ISC license.
// https://observablehq.com/@d3/color-legend
// adapted for e2h by CG 2023
legend.swatches = function(chart,element,{
  columns = null,
  format,
  unknown: formatUnknown,
  swatchSize = 15,
  swatchWidth = swatchSize,
  swatchHeight = swatchSize,
  marginLeft = 0
} = {}){
	const color = chart.scales.color;	
	const STYLE = typeof AVAA_STYLE !== "undefined" ? AVAA_STYLE : null;
	const id = `-swatches-${Math.random().toString(16).slice(2)}`;
	const unknown = formatUnknown == null ? undefined : color.unknown();
	const unknowns = unknown == null || unknown === d3.scaleImplicit ? [] : [unknown];
	const domain = color.domain().concat(unknowns);
	if (format === undefined) format = x => x === unknown ? formatUnknown : x;
	
	function escapeHtml(unsafe) //todo clean
{
    return unsafe
         .replace(/&/g, "&amp;")
         .replace(/</g, "&lt;")
         .replace(/>/g, "&gt;")
         .replace(/"/g, "&quot;")
         .replace(/'/g, "&#039;");
 }
	
	function entity(character) {
		return `&#${character.charCodeAt(0).toString()};`;
	}
  
  var s = `<div style="display: flex; align-items: center; min-height: 33px; margin-left: ${+marginLeft}px; font: 10px sans-serif;">
  <style>
.${id} {
  display: inline-flex;
  align-items: center;
  margin-right: 1em;
}

.${id}::before {
  content: "";
  width: ${+swatchWidth}px;
  height: ${+swatchHeight}px;
  margin-right: 0.5em;
  background: var(--color);
}
</style>
<div>`;
  domain.map(value => s+=`<span class="${id}" style="--color: ${color(value)}">${escapeHtml(format(STYLE ? STYLE.labelOf(value)||value : value))}</span>`);
  s+=`</div>`;
  s+=`</div>`;
  $(element).html(s);
}