/** 
@log 2024-09-16 initial
@author CG
@label Export clip
@attr format string (mp4)

Export this annotation's media clip

@dependency proc-ffmpeg-wrapper.js

**/
function(p){
	if(!p.file) throw `no media file to process`;
	let startTime = parseTime(p.start);
	let stopTime = parseTime(p.stop);
	let outDir = new java.io.File(atk.getTempPath()+"/exports");	
	if(!outDir.exists()) outDir.mkdir();
	let name = `clip_${p.af}_${p.tier}_${startTime}_${stopTime}`;
	let ext = p.file.split('.').pop();
	let outFile = atk.getTempPath()+`/exports/${name}.${ext}`;
	let ffargs = [
		'ffmpeg',
		'-y', // overwrite
		'-ss',startTime+'.0',
		'-i',p.file,
		'-c','copy',							
		'-t',(stopTime-startTime)+'.0',
		outFile
	]				
	log.info(ffargs.join(' '))
	let exe = new org.avaatoolkit.script.ScriptExecWrapper(ffargs);
	exe.run();
	log.info(`Clipping done`);
	org.avaatoolkit.util.OS.showFileInExplorer(outFile);
}

function parseTime(t){
	if(!t) return 0;
	if((t+'').includes(':')){
		let [h,m,s] = t.split(':');
		return h*3600+m*60+s*1;
	}
	return t;
}