/** 
@log 2024-09-16 initial
@author CG
@label Open in VLC
Allows opening VLC from the editor and jumping to time
**/
function(p){	
	if(!p.file) throw `missing file to open`;
	let startTime = parseTime(p.start);
	let stopTime = parseTime(p.stop);
	
	const os = org.avaatoolkit.util.OS;			
	let vlc = os.findWindowsProgram("\\VideoLAN\\VLC\\vlc.exe");
	
	if(!vlc) throw `VLC can't be found`;		//`--one-instance`
	let args = [vlc,`--stop-time=${stopTime}`, `--start-time=${startTime}`,`file:///${p.file}`]
	log.info(args.join(' '));
	java.lang.Runtime.getRuntime().exec(args);		
}

function parseTime(t){
	if(!t) return 0;
	if((t+'').includes(':')){
		let [h,m,s] = t.split(':');
		return h*3600+m*60+s*1;
	}
	return t;
}