/** 
@log 2024-09-19 initial
@author CG

Provides a login method based on JSON files

**/
function(p){		
	if(!p.id) throw `you must provide a valid user name`;
	if(!attr.path) throw `missing "path", the directory where JSON files are stored`;
	let dir = new java.io.File(attr.path);
	if(!dir.exists()) throw `directory "${attr.path}" does not exist`;
	if(!dir.isDirectory()) throw `"${attr.path}" is not a directory`;
	let userFile = new java.io.File(dir.getAbsolutePath()+'/'+p.id+'.json');
	if(!userFile.exists()) throw `no user with this id: ${p.id}`;
	let content = org.avaatoolkit.util.Utils.readFile(userFile.getAbsolutePath(),java.nio.charset.StandardCharsets.UTF_8);
	//log.info(content);
	let user = JSON.parse(content);		
	//if(user.pass!=p.password) throw `invalid password`;
	user.id = p.id;	
	delete user.pass;
	return user;
}
