/** 
@log 2023-07-21 initial
@author CG
Generates a poster with basic information about the annotation
**/
function(args){
	var text1 = args.annotation.value;
    var text2 = api.formatDuration(args.annotation.start)+" - "+api.formatDuration(args.annotation.stop);                		
	var resolution = api.converter.getSetting('poster-resolution','');
	//TODO keep ratio of resolution if provided
	var baseCommand = "-v 0 -y -f lavfi -i color=size=854x480:duration=15:rate=1:color=black -vf \"drawtext=fontfile=FONTFILE:fontsize=45:fontcolor=white:x=(w-text_w)/2:y=(h-text_h)/2-45:text='TEXT1',drawtext=fontfile=FONTFILE:fontsize=45:fontcolor=white:x=(w-text_w)/2:y=(h-text_h)/2:text='TEXT2',drawtext=fontfile=FONTFILE:fontsize=24:fontcolor=cyan:x=(w-text_w)/2:y=(h-text_h)/2+60:text='avaa-toolkit.org'\" ";
	
	cmd = baseCommand;	
	cmd = cmd.split("FONTFILE").join(ffescape(api.atk.getFontPath()));
	cmd = cmd.split("TEXT1").join(ffescape(text1));
	cmd = cmd.split("TEXT2").join(ffescape(text2));
	cmd = cmd + `-frames:v 1 "${args.output}"`;	
	api.getFFmpeg().run(cmd.split(' '));	
	if(resolution){
		resolution = resolution.split('x').join(':');
		cmd = `-v 0 -y -i "${args.output}" -vf scale=${resolution} "${args.output}"`;
		api.getFFmpeg().run(cmd.split(' '));	
	}
}

function ffescape(s){
	s = s.split(":").join("\\\\\\:");
    s = s.split("'").join("\\\\\\'");
	return s;
}