/** 
@author CG
@log 2024-08-20 initial implementation

@attr list-style select (decimal) [decimal,circle,disc,square,none] The list bullet type
@attr hide bool (false) Whether to completely hide the Table of Contents

Allows some simple customisation of the Table of Contents

**/
mod['table-of-contents'] = {
	hook:function(event){
		switch(event){			
			case '/head':							
				let css = '';				
				let bullet = attr['list-style'] || 'decimal';
				let hideToc = attr['hide']=='true';
				css += `body > toc ol { list-style-type:${bullet}; }`
				if(bullet!='decimal' || hideToc) css += `.toc-id { display:none; }`
				if(hideToc) css += `body > toc { display:none; }`
				return `<style>${css}</style>`
			case 'head':
				return '<!-- mod.table-of-contents v0.1 -->';
		}
	}
}