/** 
@deprecated
@author CG
@log 2023-20-03 initial implementation
@input None
@output Array<Annotation>

Loads JSON files resulting from forms, as virtual annotations.
This operation is deprecated and load-annotations-from-forms should be used instead.

@sample OP annotations-from-form="my form (*).json" 
**/
function(s, v , c){
	var files = api.listFiles(s);
	if(!files.length){
		log.error("No files found with filter `"+s+"`");
		return `data;`
	}
	var tiers = [];
	var ret = [];
	files.forEach(f=>{
		
		var tierName = (f.getName()+"").split("(")[1].split(')')[0];
		tiers.push(tierName);
		log.info('Reading `'+f.getName()+'` as '+tierName);
		try {
			var json = JSON.parse(api.readFile(f));			
			json.list.forEach(o=>{
				var eaf = api.getAF(o.eaf);						
				if(!eaf){
					log.warn("Can't find eaf `"+o.eaf+"` in domain");
					return;
				}
				var tier = eaf.getTier(tierName);
				if(!tier) tier = eaf.addTier({id:tierName});
				var a = eaf.addAnnotation({
					tier:tier,
					id:"",
					start:o.start,
					stop:o.stop,
					value:o.input
				});			
				ret.push(a);				
			});
		}catch(ex){
			log.warn("FAILED TO READ FILE: "+f.getName());			
		}
	});
	return ret;	
}	
