/** 
@author CG
@oldname percent-by
@input Object<String,Array<Annotation>>
@attr ~ string () [group,tier,participant,value,start,duration,file,extra.*] ~
@attr truncate int (0) Truncate factored value to X decimal places

Calculates percentage of an annotations' property value occurrence.

@sample OP calculate-percent-by="tier"
@todo @input Array<Annotation>
**/
function(value, data){
	const truncate = isNaN(attr.truncate*1) ? 0 : attr.truncate*1;
	
	//TODO
	if(Array.isArray(data)){
		return `			
			data;
		`;
	}
	let ret = {};
	Object.keys(data).map(key=>{
		var count = {};
		var total = 0;
		for(let a of data[key]){//data[key].forEach(a=>{
			let k = a.get ? a.get(value) : a[value];
			if(!count[k]) count[k]=1;
			else count[k]++;
			total++;
		};
		for(var k in count){
			count[k] = (count[k]/total)*100;
			if(truncate>-1) count[k] = truncateDecimals(count[k],truncate);
		}
		data[key] = count;
	});
	return data;

}

function truncateDecimals(number, digits) {	
    var multiplier = Math.pow(10, digits),
        adjustedNum = number * multiplier,
        truncatedNum = Math[adjustedNum < 0 ? 'ceil' : 'floor'](adjustedNum);

    return truncatedNum / multiplier;
};