/** 
@author CG
@input Array
@input Object<String,Array>
@attr ~ js () ~

Iterates over the array(s) values, and executes the provided function

@sample OP each="o => o.x = (o.x * 42) + 7"
**/
function(s, v){
	if(!v){
		log.warn(`input must be an array or an object of arrays`);
		return v;
	}
	if(!s){
		log.warn(`you must provide a filter function`);
		return v;
	}		
	if(Array.isArray(v)){
		return `data.forEach(${s});data;`;
	}
	
	return `
		Object.keys(data).map(key=>{
			data[key].forEach(${s});
		});
		data;
	`;
}