/** 
@author CG
@log 2023-03-09 initial implementation
@attr before number Seconds to add before start (default to arg)
@attr after number Seconds to add after stop (default to arg)
@attr clone bool (true) Whether to clone the annotation before changing its duration
@input Array<Annotation>
@output Array<Annotation>

Takes each input annotation and extends its duration by changing their start and/or stop times.
This will by default clone all input annotations so the originals stay unaffected.

@sample OP extend-duration="2"
**/
function(s, v){	
	var add = s*1 || 0;		
	var before = attr.before===null ? add : attr.before*1;
	var after = attr.after===null ? add : attr.after*1;
	var clone = attr.clone=='false' ? 0 : 1;
	log.debug('before='+before+" after="+after);
	before = Math.round(before*1000);
	after = Math.round(after*1000);	
	return `var ret = []
		if(!data || !data.forEach) {
			log.error("input is not an array");			
		}
		else data.forEach(a=>{
			if(!a) return ret.push(a); // preserve null references
			if(${clone}) a = a.clone();
			a.start -= ${before};
			if(a.start<0) a.start = 0;
			a.stop += ${after};
			ret.push(a);
		});
		ret;
	`;		
}