/** 
@author CG
@input Array
@input Object<String,Array>
@type js

Filters the array(s) keeping only items passing the filter expression

@sample OP filter="annotation => annotation.tier.id.contains('x')"
**/
function(s, v){
	if(!v){
		log.warn("input must be an array or an object of arrays");
		return v;
	}
	if(!s){
		log.warn("you must provide a filter function");
		return v;
	}
	if(Array.isArray(v)){
		return `
			data = data.filter(${s});
			data;
		`;
	}
	
	return `
		Object.keys(data).map(key=>{
			data[key] = data[key].filter(${s});
		});
		data;
	`;
}