/** 
@author CG
@type js
@input Object
@output Array<Object>

Transforms nested objects into a flat array of objects

@sample OP flatten="{name,value}"
@sample OP flatten="{group,name,value}"
**/
function(s, v){
	
	// TODO handle variable dimensions
	
	var dim = 1;
		
	if(s.charAt(0)=='{'){
		var a = s.substr(1).replace('}','');		
		var args = '';
		a.split(',').forEach(arg=>args+=arg+':'+arg+',');
		dim = a.split(',').length-1;
		s = `(${a})=>{ return {${args.slice(0,-1)}} }`;		
	}	
	if(s.charAt(0)=='('){
		dim = s.split(')')[0].split(',').length-1;
		//log.info('dimension '+dim);
	}		
		
	if(dim==1) return `
		var a = []
		Object.keys(data).map(t=>{
			var r = (${s})(t,data[t]);
			a.push(r);
		});
		a;
	`
	
	if(dim==2) return `
		var a = []
		Object.keys(data).map(g=>{
			Object.keys(data[g]).map(t=>{
				var r = (${s})(g,t,data[g][t]);
				a.push(r);
			});
		});
		a;	
	`
}