/** 
@author CG
@log 2024-08-20 group recursively
@input Array
@input Object<Array>
@output Object<Array>
@output Object<Object<Array>>
@attr ~ string () [group,tier,participant,value,start,duration,file,extra.*] ~

Groups the array elements by the value of a specific element's property.
The result is an object whose keys are the property values, mapped to arrays of elements.

@sample OP group-by="tier"

**/
function(prop, data){	
	const groupList = list => {
		let o = {};	
		for(let a of list){
			if(!a) continue;
			let k = a.get ? a.get(prop) : a[prop];
			if(!o[k]) o[k]=[];
			o[k].push(a);
		}
		return o;
	}
	const groupBy = v => {
		if(!v) return v;
		if(Array.isArray(v)) return groupList(v);
		if(typeof v === "object"){
			for(let k of Object.keys(v)){
				v[k] = groupBy(v[k]);
			}
		}
		return v;
	}
	return groupBy(data);
}