/** 
@author CG
@log 2023-27-02 initial implementation
@input None
@output Object
@output Array
@novalue
@dependency json5.js
@attr json js () json data
@attr file string () file name

Loads a JSON file or set data directly from embedded JSON.
The JSON file must be in the folder of the processed XML file.

@sample OP data-from-json="" _.file="myfile.json" 
@sample OP data-from-json="{foo:'bar', x:42}" 
@sample <OP data-from-json="">{json5:"works"}</OP> 

**/
function(s, v , c){
	if(!s && attr.file) s = attr.file;
	if(!s && attr.json) s = attr.json;
	if(s){
		if(s.charAt(0)=='{' || s.charAt(0)=='[') c = s;
		else {
			log.debug('loading JSON file '+s);
			try {
				c = api.readFile(s);
			}catch(ex){
				log.warn("FAILED TO READ FILE:"+s);
				return `data = {}; data;`
			}
		}
	}
	c = btoa(c);
	return `
		data = JSON5.parse(atob(`+'`'+c+'`'+`));
		data;
	`;
}	

