/** 
@author CG
@log 2023-27-02 initial implementation
@input Array
@input Object<String,Array>
@todo check if value.length is possible since it is a java String

Executes a "reducer" function on each element of the input array(s), in order, passing in the return value from the calculation on the preceding element.
The final result of running the reducer across all elements of the array is a single value.
(accumulator, currentValue) => accumulator + currentValue,  initialValue

@sample OP reduce="(totalChars, annotation) => totalChars + annotation.value.length, 0" 
**/
function(s, v){
		
	if(Array.isArray(v)){
		return `
			data = data.reduce(${s});
			data;
		`;
	}
	
	return `
		Object.keys(data).map(key=>{
			data[key] = data[key].reduce(${s});
		});
		data;
	`;
}