/** 
@author CG
@oldname select-annotations-from-tier-with-next-timecode
@log 2023-24-02 range implementation
@attr range int (0) Maximum time range to find next annotation (0 = no maximum)
@input Array<Annotation>
@output Array<Annotation>

Replaces each input annotation with one from another tier (of the same annotations' file), the first found whose start time is after input annotation's start time.

@sample OP replace-with-next-timecode-annotations-from-tier="tier id" _.range="60"
**/
function(s, v){	
	var range = attr.range*1 || 0;
	v = v.toArray ? v.toArray() : v;
	//s = `a=>a.refs.get("${s}").value`;
	return `var ret = [];		
		data = data.toArray ? data.toArray() : data;
		data.forEach(a=>{
			var count = ret.length;
			a.af.getTier("${s}").annotations.toArray().forEach(aa=>{
			    if(count+1 == ret.length) return;
				if(${range} && (Math.abs(a.start - aa.start)>${range}*1000)) return;
				if(a.start < aa.start) ret.push(aa);
			});			
		})		
		ret;
	`;
		
}