/** 
@author CG
@log 2023-02-27 initial implementation
@input Object
@input Array
@todo label filename

Saves current data to a CSV file. The file will be saved in the processed XML file's folder, overwriting any existing file.

@sample OP save-data-to-csv="table.csv" 
**/
function(s, v , c){
	if(Array.isArray(v)){
		if(!v.length){
			log.error(`the input is an empty array`);
			return v;	
		}
		if(v[0] && v[0].getExtra) {
			log.error(`input is a selection of annotations, use selection-to-data first!`);
			return v;	
		}
	}
	s = s || (api.doc.basename+'.csv');
	try {
		let f = api.writeFile(s, toCSV(data));
		api.export(f)
		log.info(`saved CSV file "${s}"`);
	}catch(ex){
		log.warn(`failed to save file: "${s}"`);
		log.error(ex.message);
	}		
	return v;	
}	

function toCSV(data){
	var json = data;
	var fields = Object.keys(json[0])
	var replacer = function(key, value) { return value === null || value === undefined ? '' : value } 
	var csv = json.map(function(row){
	return fields.map(function(fieldName){
		return JSON.stringify(row[fieldName], replacer)
	}).join(',')
	})
	csv.unshift(fields.join(',')) // add header column
	csv = csv.join('\r\n');
	return csv;
}
	