/** 
@log 2023-13-11 initial
@author CG
@input 
@output 
@novalue
@attr url string () URL to fetch for scraping
@attr file file () a file path to load content instead of an URL
@attr jsoup js () a function to extract data called with a Jsoup document as argument (to scrape HTML)
@attr js js () a function to extract data called with the content as a string argument (to scrape JSON, text files...)

Loads an URL (or a file) and extract data

@sample OP scrape="" _.url="https://en.wikipedia.org/wiki/List_of_countries_by_GDP_(nominal)"

@todo dependency envjs/rhino.js
@todo @dependency jquery.js
**/
function(s, v){				
	if(!attr.file && !attr.url){
		log.error("you must provide an URL to fetch or a file path");
		return v;
	}	
	if(attr.jsoup){
		var doc;
		if(attr.file) doc = org.jsoup.Jsoup.parse(api.readFile(attr.file));
		else if(attr.url && !doc) doc = org.jsoup.Jsoup.connect(attr.url).get();	
		if(!doc){
			log.error("can't load document");
			return v;
		}	
		try {				
			let f = new Function('return '+attr.jsoup)();
			let r = f(doc);
			return r;
		}catch(ex){
			log.error(ex.message);
		}		
	}
	if(attr.js){
		var str;
		if(attr.file) str = api.readFile(attr.file);
		else if(attr.url && !str) str = api.fetch(attr.url);
		try {				
			let f = new Function('return '+attr.js)();
			let r = f(str);
			return r;
		}catch(ex){
			log.error(ex.message);
		}		
	}
}