/** 
@author CG
@log 2023-11-06 rewrite nostringret
@log 2023-06-15 initial implementation
@novalue
@attr export-value bool (true)  
@attr export-value-as string (value)  
@attr export-tier bool (true)
@attr export-tier-as string (tier)  
@attr export-start bool (true)  
@attr export-start-as string (start)  
@attr export-stop bool (true)  
@attr export-stop-as string (stop)  
@input Array<Annotation>
@output Array<Object>

Transforms input annotations to an array of objects

**/
function(s, v){	
	var props = ['value','tier','start','stop'];	
	var exports = {}; 
	var kmap = {};
	var ret = [];		
	props.forEach(p=>exports[p]=(!(attr['export-'+p]=='false') ? 1 : 0));
	props.forEach(p=>kmap[p]=(attr['export-'+p+'-as']||p));
	if(!v || !v.forEach) {
		log.error("input is not an array");
		return ret;
	}
	var i = -1;
	v.forEach(a=>{
		i++;
		if(!a) {
			log.warn("Undefined annotation in selection");
			return;
		}
		var o = {};		
		if(exports.tier) o[kmap.tier] = a.tier ? a.tier.id : '';
		if(exports.start) o[kmap.start] = a.start;
		if(exports.stop) o[kmap.stop] = a.stop;
		if(exports.value) o[kmap.value] = a.value;
		ret.push(o);
	});
	return ret;
}