/** 
@author CG
@log 2023-11-16 initial implementation
@label name
@attr value js () a function called with current selection/data, which should return the value of the variable 

Sets a global variable which becomes available in HTML blocks as {{varname}}.
It can then be used in scripts with variables.varname,
and in attributes via the ${} syntax, like ${0.05*variables.counter}
If the "value" attribute is not defined, value saved will be the current selection/data

**/
function(name, v){	
	if(!name){
		log.error("you must provide a variable name");
		return v;
	}
	if(!attr.value){
		//log.info("no value function was provided, current data will be used");
		attr.value = 'data => data';
		//return v;
	}		
	let f = new Function('return '+attr.value)();
	try {
		let value = f(v);
		api.doc.variables[name] = value;		
		try {
			let j = JSON.stringify(value);
			if(j && j.length){
				if(j.length>50) j = j.substring(0,50)+'…';
				value = j;
			}
			
		}catch(ex){
			
		}
		//log.info('value = '+(value+'').substr(0,50));
	}catch(ex){
		log.error(ex.message);
	}		
	return v;
}