/** 
@author CG
@log 2023-11-16 initial implementation
@label name
@attr value js () a function called with current selection/data, which should return the value of the variable

Sets a global variable which becomes available in HTML blocks as {{varname}}.
Global variables can also be used in scripts with variables.varname

**/
function(name, v){	
	if(!name){
		log.error("you must provide a variable name");
		return v;
	}
	if(!attr.value){
		log.error("you must provide a value function");
		return v;
	}		
	let f = new Function('return '+attr.value)();
	try {
		let value = f(v);
		api.doc.variables[name] = value;
		log.info('value = '+(value+'').substr(0,50));
	}catch(ex){
		log.error(ex.message);
	}		
	return v;
}