/** 
@author CG
@log 2023-06-03 initial implementation
@input Array<Annotation>
@output Array<Annotation>
@attr clone bool (true)
@label tier
Changes the tier of each input annotation. By default will clone annotations so it does not affect original ones.

@sample OP set-tier="FAKE TIER"
**/
function(s, v){
	const clone = attr.clone=='false' ? 0 : 1;
	const targetTierID = utf(s);
	var ret = [];
	var tiers = {};
	for(let a of data){ // for each input annotation
		if(!a) continue; // can be null in extra block!
		if(clone) a = a.clone();
		if(!tiers[a.af.id]){ // each AF has its own tier, even with same id
			let t = a.af.getTier(targetTierID);
			if(!t) t = a.af.addTier({id:targetTierID});
			tiers[a.af.id] = t;
		}
			// todo: tier must have correct af
			//tier = a.tier.clone();			
			//tier.id = utf(s);
		
		a.tier = tiers[a.af.id]; // associate new tier
		ret.push(a);
	};
	return ret;
}