/** 
@author CG
@log 2025-01-08 added template attribute
@log 2023-06-03 initial implementation
@input Array<Annotation>
@output Array<Annotation>
@attr clone bool (true)
@label tier
Changes the tier of each input annotation. By default will clone annotations so it does not affect original ones.
@attr template js () A function called for each annotation, that must return its new tier name, like (annotation,tier)=>`${tier.id} 2`

@sample OP set-tier="FAKE TIER"
**/
function(s, v){
	const clone = attr.clone=='false' ? 0 : 1;
	const targetTierID = utf(s); //todo check wtf with utf
	const ret = [];
	const tiers = {};
	var template = attr['template'] || '';
	if(template){
		if(template.charAt(0)=='`') template = '(annotation,tier)=>'+template;
		template = new Function('return '+template)();
	}
	for(let a of data){ // for each input annotation
		if(!a) continue; // can be null in extra block!
		if(clone) a = a.clone();
		let newTierID = template ? template(a,a.tier) : targetTierID;
		let t = a.af.getTier(newTierID);
		if(!t) t = a.af.addTier({id:newTierID});
		
		//if(!tiers[a.af.id]){ // each AF has its own tier, even with same id
			
			//tiers[a.af.id] = t;
		//}		
		a.tier = t;//tiers[a.af.id]; // associate new tier
		ret.push(a);
	};
	return ret;
	
		// todo: tier must have correct af
		//tier = a.tier.clone();			
		//tier.id = utf(s);

}