/** 
@author CG
@input Array<Annotation>
@output Array<Annotation>
@novalue

@attr order string [+/-] (+) (ascending/descending) Sorting order of the AF groups
@attr field string () A field to sort on, like "+start"

Sorts annotations first by their file, and then by the provided field or compare function.
When providing a field, first character must indicate sorting order with +/- (ascending/descending)

@sample OP sort-by-file=""
@sample OP sort-by-file="+start"
@sample OP sort-by-file="-start"
@sample OP sort-by-file="(a1,a2) => a1.start > a2.start ? -1 : 1"
**/
function(s,v){
	
	if(v.sort == null) throw "trying to sort a non sortable object";	
	var afOrd = attr.order=='-' ? '1:-1' : '-1:1';
	// default sort if empty arg
	if(!s) s=attr.field || "+start";	
	
	var cb = `(a,b)=>{ return a.af.filename+"" == b.af.filename+"" ? `;
	// check for +field or -field shortcuts	
	var c = s.charAt(0);
	if(c=='+'||c=='-'){
		var k = s.substr(1);
		var ord = c=='-' ? '1:-1' : '-1:1';		
		cb += `( a["${k}"] < b["${k}"] ? ${ord} )`;
	}else{		
		// we expect an anonymous function
		cb += `( (${s})(a,b) )`;
	}
	cb += ` : (a.af.filename+"" < b.af.filename+"" ? ${afOrd} ) }`;
	log.debug(cb);	
	return `
		data.sort(${cb});
		data;
	`;
}