/** 
@author CG
@log 2023-08-24 initial
@input Array<Annotation>
@output Array<Annotation>
@novalue

@attr order string [+,-] (+)  Sorting order of groups (ascending/descending)
@attr natural bool (false) Natural integer sorting instead of string
@attr field string () A field to sort on, like "+start"

Sorts annotations by their group, and then inside each group by their relative start time (using eventual file time-offset)
If no field is provided, sorting will be done around //TODO

@sample OP sort-by-group=""

**/
function(s,v){
	
	if(v.sort == null) throw "trying to sort a non sortable object";	
	var afOrd = attr.order=='-' ? '1:-1' : '-1:1';
	// default sort if empty arg
	if(!s) s=attr.field || "+start";	
	
	var cb = `(a,b)=>{ return a.af.group == b.af.group ? `;
	// check for +field or -field shortcuts	
	var c = s.charAt(0);
	if(c=='+'||c=='-'){
		var k = s.substr(1);
		var ord = c=='-' ? '1:-1' : '-1:1';		
		cb += `( a["${k}"] < b["${k}"] ? ${ord} )`;
	}else{		
		// we expect an anonymous function
		cb += `( (${s})(a,b) )`;
	}
	cb += ` : (a.af.group < b.af.group ? ${afOrd} ) }`;
	log.debug(cb);	
	return `
		data.sort(${cb});
		data;
	`;
}