/** 
@author CG
@log 2023-09-04 added natural sort
@input Array
@output Array
@label field
@attr natural bool (false) Whether to sort based only on the digits contained in the field, and not string comparison

Sorts input array by a given field

@sample OP sort="-start" 
**/
function(s,v){
		
	if(v.sort == null) throw "trying to sort a non sortable object";

	var natural = attr.natural=='true' ? 1 : 0;

	// default sort if empty arg
	if(!s) s='(a,b)=>a<b?1:-1';

	// check for +field or -field shortcuts
	var c = s.charAt(0)
	if(c=='+'||c=='-'){
		var k = s.substr(1);
		var ord = c=='-' ? '1:-1' : '-1:1';
		s = `(a,b)=>readValue(a.get ? a.get("${k}") : a["${k}"],${natural})<readValue(b.get ? b.get("${k}") : b["${k}"],${natural})?`+ord;
	}
	
	return `
		data.sort(${s});
		data;
	`;
}

function readValue(v,natural){
	if(natural) return v && v.replace ? (v.replace(/[^\d.-]/g, '') * 1) : v;
	return v;	
}

