/** 
@author CG
@log 2023-11-27 migration to processor 

@input Array<Annotation>
@experimental
@attr video-resolution string () Resolution of converted video (like 1280x720)
@attr audio-volume number (1) [0 1] Audio volume

@dependency proc-ffmpeg-wrapper.js
@dependency milliseconds-to-time.js


Use Media Converter to convert video and audio files into other formats

**/
proc['media-converter'] = {	
	pipe:pipe=>{		
		for(let f of pipe.domain){
			let step = log.addStep(f);
			if(!f.media.size()) {
				step.error(`No media file available in ${eafid}`);		
				continue;
			}			
			for(let pmf of f.media){
				if(api.isEstimateMode()) {
					api.converter.progressTodo(100*1000);
					continue;
				}
				step.file(pmf,`Input = `);	
				if(!pmf.exists()) {
					step.error(`Media file "${pmf.getAbsolutePath()}" not found`);
					continue;
					//return false; // abort pipe
				}
				if(api.isPreviewMode()){
					step.info(`Not processing because preview mode.`)
					continue;
				}				
				let targetFile = pipe.temp(pmf);
				step.file(targetFile,`Output = `);				
				let ffargs = ['-y','-i',pmf.getAbsolutePath()];
				if(attr['video-resolution']){
					ffargs.push('-vf','"scale='+attr['video-resolution'].replace('x',':')+'"')
				}
				//if(attrFormat){
					//ffargs.push(attrFormat);				
				//}
				
				ffargs.push(targetFile.getAbsolutePath())	
				//step.info(ffargs.join(' '));
				step.info(`Converting...`)
				step.work();
				let rs = ffmpegWrapper(step,ffargs,{
					onProgress:o=>api.converter.progressDone(o.percentChunk*1000),
				});
				if(!rs) {
					step.error(`Media file "${pmf.getAbsolutePath()}" could not be processed`);
					continue;
					//return false; // abort pipe
				}
				pmf.replaceWith(targetFile);
				continue;	
			} // end of media
 		} // end of domain file		
	}
}
