/** 
@author CG
@input Array<Annotation>
@log 2023-11-27 migration to processor 
@experimental
Video Merger is a special view that combines into one video file all the provided annotation segments.

**/
proc['video-merger'] = {	
	list:list=>{		
		if(!list || !list.length) throw "no annotation was provided";
		
		var isTest = api.converter.getSetting('test-mode')=='true';
		if(isTest){
			log.info("Skipped merging because test mode");			
		}
		
		var files = "";
		var logitem = {name:"files",list:[]};	
		
		//-filter_complex "[0:v] [0:a] [1:v] [1:a] [2:v] [2:a] concat=n=3:v=1:a=1 [v] [a]" 
		var inputs = "";
		var cf =  "";
		
		var i = 0;
		var last = list.length*2;
		var cfscale = "";
		list.forEach(a=>{
			var f = api.toAbsolutePath(a.clip());
			f = f.split('\\').join('/');
			inputs += `-i "${f}" `
			inputs += `-i "D:/work/VGM/VGMQ/vgk_1526492297_f27fc1d0baca6250c1a5f4ea71b15e56.jpg" -t 5 `
			files+="file "+f+"\n";
			files+="file D:/work/VGM/VGMQ/vgk_1526492297_f27fc1d0baca6250c1a5f4ea71b15e56.jpg\noutpoint 5\n";
			cf += `[${i}:v][${i}:a] `;
			i++;
			cfscale += `[${i}:v]scale=1280:534[${i}:v];`
			cf += `[${i}:v][${last}:a] `;
			
			i++;
			logitem.list.push(f);
			//log.info(f);
		});
		inputs += "-f lavfi -t 0.1 -i anullsrc=channel_layout=stereo:sample_rate=44100"
		cf+=`concat=n=${i}:v=1:a=1 [v] [a]`;
		
		var f = api.writeFile("video-merger-files.txt",files);
		var cmd = `ffmpeg ${inputs.trim()} -filter_complex "${cfscale} ${cf}" -map "[v]" -map "[a]" MuxFinal.mp4`;
		//log.info(cmd);
		log.report(logitem);
		return;			
	}
}
