/** 
@author CG
@log 2023-01-08 initial implementation
@log 2023-11-16 interpolation with global variables
Inserts raw HTML. Content must be specified as a CDATA block
HTML can be templated with global {{variables}}

**/
tag.html = {
	build:(element, attr, content)=>{
		var html = String(element.getTextContent());
		for(var k in variables){
			var kk = `{{${k}}}`;
			if(html.indexOf(kk)<0) continue;
			html = html.split(kk).join(variables[k]);
		};
		var tok1 = "<?"
		var tok2 = "?>"
		var pos;
		while((pos = html.indexOf(tok1))>-1){			
			let customJS = html.substring(pos+tok1.length,html.indexOf(tok2));
			let result = '';
			let f = new Function('return () => { '+customJS.trim()+'}')();
			try {
				result = f();
			}catch(ex){
				log.error(ex.message);
			}		
			//log.info(customJS);			
			
			html = html.substring(0, pos) + result + html.substring(html.indexOf(tok2)+tok2.length);
		}
		return html;
	}	
}