/** 
@author CG
@input Object
@input Array

Displays JSON serializable data as an interactive tree.

@sample VIEW 
@image png
**/
view.json = {	
	includes:['jsonTree.js','jsonTree.css','icons.svg'],
	data:data=>{		
		if(attr.hidden=='true') return '';
		if(data instanceof java.util.ArrayList){
			log.warn("!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!");
		}
		try {
			if(!(typeof data == 'string')) {
				data = JSON.stringify(data);
			}
		}catch(ex){
			log.info(dataJSON);
			return `<p class="error">data is not JSON serializable (`+ex.message+`)</p>`
		}

		data = btoa(encodeURIComponent(data));
		var s = `<div style="visibility:hidden;" class="json-tree">${data}</div>`		
		return s;
	},
	js:s=>{
		$(function(){
			if(!window.jsonTree) return alert("jsontree is missing, can't display data trees");
			$('.view-json .json-tree').each((i,e)=>{
				try {
					var j = JSON.parse(decodeURIComponent(atob($(e).html())));
					$(e).html('');
					$(e).css('visibility','visible');
					if(typeof j == 'array' || typeof j == 'object'){
						jsonTree.create(j, e);
					}else{
						console.warn("[view-learn] unhandled data type:",typeof j,j);
					}
				}catch(ex){
					console.warn(ex);
				}
			});
		});
	},
	css:s=>{
		return `
		#view p.error {
			color:red;font-weight:bold;
		}
		#view .json-tree ul {	
			list-style: none;
			padding: 0px;
		}
`;
	}
}
