/** 
@author CG
@input Array<LearnItem>
@internal
**/
view.learn = {	
	dependencies:['jsonTree.js','jsonTree.css','rainbow.js','rainbow.css','icons.svg'],
	list:list=>{		
		var h = ['after','eq','before','mode','count','query'];
		var s = '<table><thead><tr>';
		var td = [];
		h.forEach(att=>{			
			td.push(att);			
		});				
		td.forEach(att=>s+='<td>'+(att)+'</td>');			
		s+='</tr></thead><tbody>';
		var idx=0;
		list.forEach(item=>{
			idx++;
			if(item.extra){
				//TODO
				
			}
			if(item.type=='OP'){
				s+=`<tr><td colspan="50">`;
				
				var count = '';
				if(item.outputJSON){
					try{
						var j = JSON.parse(item.outputJSON);
						if(j && j.length!==undefined) count=j.length;
					}catch(ex){}
				}
				
				s+=`<span class="learn-block op-learn"><b>${count} &#128498; ${item.id} </b>`;
				
				s+=`<code data-language="javascript">${esc(item.arg)}</code>`;
				
				s+=`<span class="op-types"><i>${esc(item.inputClass)}</i> &rArr; `;
				s+=`<i>${esc(item.outputClass)}</i></span></span>`;
				if(item.outputJSON){
					//log.info(item.outputJSON);
					var b64 = btoa(encodeURIComponent(item.outputJSON));
					s+=`<div class="learn-content">`;
					s+=`<div class="json-tree">${item.outputJSON}</div>`;
					s+=`<div><a href="#" class="learn-dljson" data-json="${b64}" data-name="">Download JSON</a></div>`;
					s+=`</div>`;
				}
				s+=`</td></tr>`;
				return;
			}
			if(item.type=='STACK'){
				s+=`<tr><td colspan="50">`;
				var mode =  '&#x2206;';
				if(item.mode=='*') mode = '&#x2229;'; //intersect
				s+=`<span class="learn-block learn-stack"><b>${item.annotations.size()} ${mode} stack</b>`;
				
				s+=`<div class="learn-content">`;
				var a = [];
				item.annotations.forEach(an=>a.push(an.toString()));
				s+=`<div class="json-tree">${JSON.stringify(a)}</div>`;				
				s+=`</div>`;
				
				s+=`</td></tr>`;
				return;
			}			
			if(item.type=='UNSTACK'){
				s+=`<tr><td colspan="50">`;
				s+=`<span class="learn-block learn-unstack"><b>${item.annotations.size()} &#x2207; unstack</b>`;
				s+=`<div class="learn-content">`;
				var a = [];
				item.annotations.forEach(an=>a.push(an.toString()));
				s+=`<div class="json-tree">${JSON.stringify(a)}</div>`;				
				s+=`</div>`;
				
				s+=`</td></tr>`;
				return;
			}			
			if(item.type=='SAVE'){
				s+=`<tr><td colspan="50">`;
				s+=`<span class="learn-block learn-unstack"><b>${item.annotations.size()} &#x1F5AB; save</b>`;
				s+=`<div class="learn-content">`;
				var a = [];
				item.annotations.forEach(an=>a.push(an.toString()));
				s+=`<div class="json-tree">${JSON.stringify(a)}</div>`;				
				s+=`</div>`;
				
				s+=`</td></tr>`;
				return;
			}			
			if(item.type=='LOAD'){
				s+=`<tr><td colspan="50">`;
				s+=`<span class="learn-block learn-unstack"><b>${item.annotations.size()} &#x1F5C1; load</b>`;
				s+=`<div class="learn-content">`;
				var a = [];
				item.annotations.forEach(an=>a.push(an.toString()));
				s+=`<div class="json-tree">${JSON.stringify(a)}</div>`;				
				s+=`</div>`;
				
				s+=`</td></tr>`;
				return;
			}			
			s+=`<tr class="learn-an">`;
			td.forEach(att=>{
				
				s+='<td class="td-'+att+'">';
				switch(att){
				 case 'after':
					s+='<b>'+item[att]+'</b>';
					break;
				case 'eq':
					s+=' = ';
					break;
				case 'query':		
					if(item.type=='JS') s+='<i>'+item.desc+'</i>';
					else s+='<code data-language="html">'+item[att]+'</code>';
					break;
				case 'mode':
					if(item.type=='JS') s+='&#128498;';
					else {
						if(item[att]=='*') s+='&#x2229;';
						else s+=item[att];
					}
					//s+='<i>'+item.type+'</i>';
					break;
				case 'count':
					if(item.type=='JS') s+='JS';
					else s+=item[att];
					break;
				default:
					s+=item[att];				
				}
				s+="</td>";
			});
			s+='</tr>';
			s+=`<tr class="learn-an-content learn-content">`;
			s+=`<td colspan="50">`;
			
				var a = [];
				item.annotations.forEach(an=>a.push(an.toString()));
				s+=`<div class="json-tree">${JSON.stringify(a)}</div>`;							
				
				s+=`</td></tr>`;							
		});
		s+='</tbody></table>';
		return s;
	},
	js:s=>{
		$(function(){
			$('.learn-block').click(ev=>{		
				$(ev.currentTarget).parent().find('.learn-content').toggle();
			});
			$('.learn-an').click(ev=>{		
				$(ev.currentTarget).next().toggle();
			});
			$('a.learn-dljson').click(ev=>{
				if(!window.saveAs) return alert("filesaver.js is missing, can't save file.");
				var b = new Blob([decodeURIComponent(atob($(ev.currentTarget).attr('data-json')))], {type: "text/plain;charset=utf-8"});
				window.saveAs(b, $(ev.currentTarget).attr('data-name') || 'op.json', {type:'application/json'});
				ev.preventDefault();
				ev.stopPropagation();
			});
			if(!window.jsonTree) return alert("jsontree is missing, can't display data trees");
			$('.view-learn .json-tree').each((i,e)=>{
				try {
					var j = JSON.parse($(e).html());
					$(e).html('');
					if(typeof j == 'array' || typeof j == 'object'){
						jsonTree.create(j, e);
					}else{
						console.warn("[view-learn] unhandled data type:",typeof j,j);
					}
				}catch(ex){
					console.warn(ex);
				}
			});
		});
	},
	css:s=>{
		return `
#view .json-tree ul {
    list-style: none;
    padding: 0px;
}
#view tr:hover .op-types {
	visibility:visible;
}
#view .op-types {
	float: right;
    font-size: 12px;
	position:relative;
	top:5px;
	visibility:hidden;	
}
#view .learn-block {
	cursor:pointer;
}
#view .learn-an {
	cursor:pointer;
}
#view .learn-content {
	display:none;
}
#view code span {
    letter-spacing: -1px;
}
#view thead {
	display:none;
}
#view table {
    border-collapse: collapse;
    margin: 7px;
}
#view {
	border-left: 3px solid gainsboro;
	margin: 7px;
}
#view td {
    border-bottom: 1px solid gainsboro;    
	padding-right: 5px;
}
`;
	}
}
