/** 
@author CG

A special view to display testcase results.

**/
view.testcase = {		
	data:data=>{
		var s = "";
		s+=`<table>`;
		var k = 0;
		learnList.toArray().forEach(i=>{			
			if(i.type=='TEST'){
				s+=`<tr><td>${++k}</td><td>${i.pass ? '<i style="color:green">PASS</i>' : '<i style="color:red">FAIL</i>'}</td><td><b>${i.name}</b></td><td>${esc(i.code)}</td></tr>`;	
			}
			
		});
		s+=`</table>`;
		return s;	
	},
	js:s=>{
		$(function(){
			$('.learn-block').click(ev=>{		
				$(ev.currentTarget).parent().find('.learn-content').toggle();
			});
			$('.learn-an').click(ev=>{		
				$(ev.currentTarget).next().toggle();
			});
			$('a.learn-dljson').click(ev=>{
				if(!window.saveAs) return alert("filesaver.js is missing, can't save file.");
				var b = new Blob([decodeURIComponent(atob($(ev.currentTarget).attr('data-json')))], {type: "text/plain;charset=utf-8"});
				window.saveAs(b, $(ev.currentTarget).attr('data-name') || 'op.json', {type:'application/json'});
				ev.preventDefault();
				ev.stopPropagation();
			});
			if(!window.jsonTree) return alert("jsontree is missing, can't display data trees");
			$('.view-learn .json-tree').each((i,e)=>{
				try {
					var j = JSON.parse($(e).html());
					$(e).html('');
					if(typeof j == 'array' || typeof j == 'object'){
						jsonTree.create(j, e);
					}else{
						console.warn("[view-learn] unhandled data type:",typeof j,j);
					}
				}catch(ex){
					console.warn(ex);
				}
			});
		});
	},
	css:s=>{
		return `
#view .json-tree ul {
    list-style: none;
    padding: 0px;
}
#view tr:hover .op-types {
	visibility:visible;
}
#view .op-types {
	float: right;
    font-size: 12px;
	position:relative;
	top:5px;
	visibility:hidden;	
}
#view .learn-block {
	cursor:pointer;
}
#view .learn-an {
	cursor:pointer;
}
#view .learn-content {
	display:none;
}
#view code span {
    letter-spacing: -1px;
}
#view thead {
	display:none;
}
#view table {
    border-collapse: collapse;
    margin: 7px;
}
#view {
	border-left: 3px solid gainsboro;
	margin: 7px;
}
#view td {
    border-bottom: 1px solid gainsboro;    
	padding-right: 5px;
}
`;
	}
}
