# Basic WebLiero Extended Room

## Setup Browser Redirection
- install Requestly or extension of your choice to rewrite requests URLs
- setup a redirection rule to match URL containing ``headless-min.js`` 
- redirect it to ``https://www.vgm-quiz.com/dev/webliero/headless-extended-latest.js``

## Launch Headless Room
- get token from https://www.webliero.com/headlesstoken
- go to https://www.webliero.com/headless
- open the browser console (Ctrl+Shift+I)
- paste the following script (replacing with your headless token)

```
room = WLInit({
    token: "YOUR.HEADLESS.TOKEN",
    roomName: "extended experiment",
    noPlayer: true,
    maxPlayers: 12,
    public: false
});

room.setSettings({
    scoreLimit: 20,
    timeLimit: 10000,
    respawnDelay: 1,
    bonusDrops: "health",
    maxDuplicateWeapons: 0,
    loadingTimes: 0.4,
    levelPool: "arenasBest",
    expandLevel: false
});

room.onPlayerJoin = player => {
    /*if(player.auth == "1BebeExCRILItGtdg2hxRZhw_sq4QhCYMvTzSkcyy6E")*/ room.setPlayerAdmin(player.id, true);
    room.sendAnnouncement("Welcome " + player.name + "!", player.id, 0x00FF00, "bold", 1);
}
```

To connect, use the provided link but replace webliero.com with ext-proxy.fly.dev
To change mod, use /loadmodext or /lm instead of /loadmod

After a browser restart, press Up in the console to load last script, just update token.
